/*
 * Informe para la FIDE
 */

Function InFIDE(CFHtm)
local cFechaw, lError:=.F.

  //dbselectarea('cuadro')

  cFechaw:=if(torneos->fecha_ini<>torneos->fecha_fin,'del '+ ;
            dtoc(torneos->fecha_ini)+' al '+dtoc(torneos->fecha_fin),dtoc(torneos->fecha_ini))
  HtmFich := Html_Ini("\"+CurDir()+"\"+cFHtm+".htm",alltrim(torneos->torneo),;
             trim(torneos->localidad)+', '+cFechaw)

  Html_LineText(HtmFich, '<p class="updated">Informe del torneo para la FIDE')
  Html_Line(HtmFich)

  Html_Text(HtmFich,'<p class="normaltext">Ritmo de juego: '+trim(torneos->prim_contr)+;
     if(len(trim(torneos->segu_contr))>0,' + '+torneos->segu_contr,'')+'</p>')
  Html_Text(HtmFich,'<p>rbitro principal: '+trim(torneos->arbit_ppal)+'</p>')
  Html_Text(HtmFich,'<p>Cuadro del torneo: (Ver hoja adjunta)</p>')
  Html_Text(HtmFich,'<p>Resultados FIDE:</p>')
  Html_Text(HtmFich,'<pre>')

   dbselectarea('cuadro')
   // Comprobar que no faltan datos de los FIDEs
   dbeval( { ||ComprJugFIDE() } , { || len(trim(cuadro->cod_fide))>0 .or. cuadro->elofide>0 } )

   if lError
      MsgInfo('Errores en datos FIDE. Corrijalos y ejecute de nuevo')

   else

      Html_LineTextK(HtmFich,'Cd.FIDE Nombre'+space(25)+'Sexo Pas Fec.Nacim. Puntos Partidas Elo Rivales N Ranking')

      // Enviar al informe los datos de los FIDEs
      dbeval( { ||ProcJugFIDEInf(HtmFich) } , { || len(trim(cuadro->cod_fide))>0 .or. cuadro->elofide>0 } )

   ENDIF

   Html_LineTextK(HtmFich,'')
   Html_Text(HtmFich,'</pre>')
   Html_Text(HtmFich,'<p></p>')
   Html_Text(HtmFich,'<p>Bloques FIDE:</p>')
   Html_Text(HtmFich,'<pre>')


   Html_LineTextK(HtmFich,'Nombre'+space(25)+'Sexo Pas Fec.Nacim. Puntos Partidas Elo Rivales N Ranking')


   // Enviar al informe los datos de los no FIDE con bloque
   dbeval( { ||ProcBloqFIDEInf(HtmFich) } , { || len(trim(cuadro->cod_fide))=0 .and. cuadro->elofide=0 } )

  Html_Text(HtmFich,'</pre>')
  Html_Text(HtmFich,'<p></p>')
  Html_Line(HtmFich)
  Html_Text(HtmFich,'<p align="right">Firmado: '+trim(torneos->arbit_ppal)+'</p>')

  MsgInfo('Fichero "Kersuizo.htm" con el informe para la FIDE creado')

Return nil

/*
 * Informe de variaciones de elo para FIDE
 */

Function ProcJugFIDEInf(HtmFich)
Local nW:=0, nN:=0, nRc:=0, nNReg
Local nRda, cCJug, nEloJug, cLin

   //Hacer calculos
   nNReg:=cuadro->(recno())
   nEloJug:=cuadro->elofide //para tener en cuenta el tema de los 350 puntos

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elofide>0
            // El rival tiene FIDE -> acumular
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            Do case
            case cuadro->elofide-nEloJug>350
               nRc+=nEloJug+350
            case nEloJug-cuadro->elofide>350
               nRc+=nEloJug-350
            otherwise
               nRc+=cuadro->elofide
            endcase
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Escribir datos del jugador
   cLin:=''
   cLin+=cuadro->cod_fide+' '
   cLin+=cuadro->jug+' '
   cLin+=cuadro->sexo+'    '
   cLin+=cuadro->cod_pais+'  '
   cLin+=dtoc(cuadro->fecha_nac)+' '
   cLin+=str(nW,4,1)+'   '
   cLin+=str(nN,2)+'       '
   cLin+=str(nRc,4)+'        '

   cLin+=str(cuadro->num,3)+' '

   Html_LineTextK(HtmFich,cLin)

RETURN NIL

/*
 * Informe de bloques de elo para FIDE
 */

Function ProcBloqFIDEInf(HtmFich)
Local nW:=0, nN:=0, nRc:=0, nNReg
Local nRda, cCJug, cCInc, cCPtos

   //Hacer calculos
   nNReg:=cuadro->(recno())

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elofide>0
            // El rival tiene FIDE -> acumular
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            nRc+=cuadro->elofide
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Grabar registro si ha hecho serie (3 o mas rivales con FIDE)
   if nN>=3

      cLin:=''
      //cLin+=cuadro->cod_fide+' '
      cLin+=cuadro->jug+' '
      cLin+=cuadro->sexo+'    '
      cLin+=cuadro->cod_pais+'  '
      cLin+=dtoc(cuadro->fecha_nac)+' '
      cLin+=str(nW,4,1)+'   '
      cLin+=str(nN,2)+'       '
      cLin+=str(nRc,4)+'        '

      cLin+=str(cuadro->num,3)+' '

      Html_LineTextK(HtmFich,cLin)

   ENDIF

Return nil

/*
 * Fichero de variaciones de elo para FIDE
 */

Function FiFIDE()
local cFich:='KsFIDE', lError:=.f.

   /* Elegir nombre de fichero, de momento no doy la opcin
   LOAD WINDOW ksronda AS FrmElegRda

      FrmElegRda.lblFichero.Visible:=.f.
      FrmElegRda.txtFichero.Visible:=.f.
      FrmElegRda.lblRonda.Row:=40
      FrmElegRda.cbxRdas.Row:=40

     CENTER WINDOW FrmElegRda
     ACTIVATE WINDOW FrmElegRda
   */

   // Crear fichero
   use (cUnidadProg+':\'+cCaminoProg+'\ks\KsFIDE.mod') new
   COPY STRU TO (cFich)
   use (cFich) alias ksfide exclusive

   dbselectarea('cuadro')
   // Comprobar que no faltan datos de los FIDEs
   dbeval( { ||ComprJugFIDE() } , { || len(trim(cuadro->cod_fide))>0 .or. cuadro->elofide>0 } )

   if lError
      MsgInfo('Errores en datos FIDE. Corrijalos y ejecute de nuevo')

   else

      // Enviar al fichero los datos de los FIDEs
      dbeval( { ||ProcJugFIDE() } , { || len(trim(cuadro->cod_fide))>0 .or. cuadro->elofide>0 } )

      ksfide->(dbclosearea())
      MsgInfo('Fichero '+cFich+'.dbf con datos para la FIDE creado')

   endif

Return nil

/*
 * Comprobar datos de un jugador FIDE
 */

Function ComprJugFIDE()

if len(trim(cuadro->cod_fide))>0 .and. cuadro->elofide<=0

   MsgInfo('Error. El jugador '+trim(cuadro->jug)+' no tiene bien el Elo FIDE')
   lError:=.t.

endif

if len(trim(cuadro->cod_fide))=0 .and. cuadro->elofide>0

   MsgInfo('Error. El jugador '+trim(cuadro->jug)+' no tiene bien el Cdigo FIDE')
   lError:=.t.

endif

Return nil

/*
 * Tratar un jugador FIDE
 */

Function ProcJugFIDE()
Local nW:=0, nN:=0, nRc:=0, nNReg
Local nRda, cCJug, nEloJug

   //Hacer calculos
   nNReg:=cuadro->(recno())
   nEloJug:=cuadro->elofide //para tener en cuenta el tema de los 350 puntos

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elofide>0
            // El rival tiene FIDE -> acumular
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            Do case
            case cuadro->elofide-nEloJug>350
               nRc+=nEloJug+350
            case nEloJug-cuadro->elofide>350
               nRc+=nEloJug-350
            otherwise
               nRc+=cuadro->elofide
            endcase
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Grabar registro
   dbselectarea('ksfide')
   dbappend()
   replace ksfide->id_code   with cuadro->cod_fide
   replace ksfide->name      with cuadro->jug
   replace ksfide->sex       with cuadro->sexo
   replace ksfide->country   with cuadro->cod_pais
   replace ksfide->birthdate with cuadro->fecha_nac
   replace ksfide->w         with nW
   replace ksfide->n         with nN
   replace ksfide->rc        with nRc

   replace ksfide->n_ranking with cuadro->num

   dbselectarea('cuadro')

Return nil

/*
 * Fichero de jugadores con bloque de elo para FIDE
 */

Function FiBloqFIDE()
private cFich:='KsFIDEBloq', lAlgunBloque:=.f.

   // Crear fichero (se crea slo si hay alguno con bloque)
   /*
   use (cUnidadProg+':\'+cCaminoProg+'\ks\KsFIDE.mod') new
   COPY STRU TO (cFich)
   use (cFich) alias ksfide exclusive
   */
   dbselectarea('cuadro')

   // Enviar al fichero los datos de los no FIDE con bloque
   dbeval( { ||ProcBloqFIDE() } , { || len(trim(cuadro->cod_fide))=0 .and. cuadro->elofide=0 } )

   if lAlgunBloque
      ksfide->(dbclosearea())
      MsgInfo('Fichero '+cFich+'.dbf con bloques para la FIDE creado')
   else
      MsgInfo('No ha habido ningn bloque FIDE en el torneo')
   endif

Return nil

/*
 * Tratar un jugador no FIDE para ver si ha hecho bloque
 */

Function ProcBloqFIDE()
Local nW:=0, nN:=0, nRc:=0, nNReg
Local nRda, cCJug, cCInc, cCPtos

   //Hacer calculos
   nNReg:=cuadro->(recno())

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elofide>0
            // El rival tiene FIDE -> acumular
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            nRc+=cuadro->elofide
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Grabar registro si ha hecho serie (3 o mas rivales con FIDE)
   if nN>=3

      if lAlgunBloque=.f.
         lAlgunBloque:=.t.
         // Crear fichero
         use (cUnidadProg+':\'+cCaminoProg+'\ks\KsFIDE.mod') new
         COPY STRU TO (cFich)
         use (cFich) alias ksfide exclusive
      endif

      dbselectarea('ksfide')
      dbappend()
      //replace ksfide->id_code   with cuadro->cod_fide
      replace ksfide->name      with cuadro->jug
      replace ksfide->sex       with cuadro->sexo
      replace ksfide->country   with cuadro->cod_pais
      replace ksfide->birthdate with cuadro->fecha_nac
      replace ksfide->w         with nW
      replace ksfide->n         with nN
      replace ksfide->rc        with nRc

      replace ksfide->n_ranking with cuadro->num
   endif
   dbselectarea('cuadro')

Return nil

/*
 * Fichero de variaciones de elo para FVA
 */

Function FiFVA()
local cFich:='KsFVA', lError:=.f.

   // Crear fichero
   use (cUnidadProg+':\'+cCaminoProg+'\ks\KsFVA.mod') new
   COPY STRU TO (cFich)
   use (cFich) alias ksfva exclusive

   dbselectarea('cuadro')
   // Comprobar que no faltan datos de los FIDEs
   //dbeval( { ||ComprJugFIDE() } , { || len(trim(cuadro->cod_fide))>0 .or. cuadro->elofide>0 } )

   // Enviar al fichero los datos de los FVAs
   dbeval( { ||ProcJugFVA() } , { || len(trim(cuadro->lic))>0 } )

   ksfva->(dbclosearea())
   MsgInfo('Fichero '+cFich+'.dbf con datos para la FVA creado')

Return nil

/*
 * Tratar un jugador FVA
 */

Function ProcJugFVA()
Local nNReg, nN:=0, nW:=0, nRc:=0
Local nEloJug, nRda, cCJug, cCInc, cCPtos, nElo

   //Hacer calculos
   nNReg:=cuadro->(recno())
   nEloJug:=cuadro->elo //para tener en cuenta el tema de los 350 puntos

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elo>0 .or. cuadro->eloFIDE>0 .or. cuadro->eloFEDA>0
            // El rival tiene elo -> acumular
            //Buscar elo ms adecuado
            Do case
            case cuadro->elo>0
               nElo:=cuadro->elo
            case cuadro->eloFIDE>0
               nElo:=cuadro->eloFIDE
            othe
               nElo:=cuadro->eloFEDA
            endcase
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            Do case
            case nElo-nEloJug>350
               nRc+=nEloJug+350
            case nEloJug-nElo>350
               nRc+=nEloJug-350
            otherwise
               nRc+=nElo
            endcase
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Grabar registro
   dbselectarea('ksfva')
   dbappend()
   replace ksfva->torneo     with torneos->torneo
   replace ksfva->localidad  with torneos->localidad
   replace ksfva->fecha_ini  with torneos->fecha_ini
   replace ksfva->fecha_fin  with torneos->fecha_fin
   replace ksfva->licencia   with cuadro->lic
   replace ksfva->puntos     with nW
   replace ksfva->partidas   with nN
   replace ksfva->elorivales with nRc

   dbselectarea('cuadro')

Return nil

/*
 * Fichero de jugadores nuevos, sin licencia de la FVA
 */

Function FiNueFVA()
private cFich:='KsFVANuevos', lAlgunNuevo:=.f.

   // Crear fichero (se crea slo si hay alguno con bloque)
   dbselectarea('cuadro')

   // Enviar al fichero los datos de los sin licencia FVA
   dbeval( { ||ProcNueFVA() } , { || len(trim(cuadro->lic))=0 } )

   if lAlgunNuevo
      ksfvanue->(dbclosearea())
      MsgInfo('Fichero '+cFich+'.dbf con jugadores nuevos para la FVA creado')
   else
      MsgInfo('No ha habido ningn jugador sin Licencia por la FVA en el torneo')
   endif

Return nil

/*
 * Tratar un jugador no FIDE para ver si ha hecho bloque
 */

Function ProcNueFVA()
Local nNReg, nN:=0, nW:=0, nRc:=0
Local nEloJug, nRda, cCJug, cCInc, cCPtos, nElo

   //Hacer calculos
   nNReg:=cuadro->(recno())
   nEloJug:=cuadro->elo //para tener en cuenta el tema de los 350 puntos

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elo>0 .or. cuadro->eloFIDE>0 .or. cuadro->eloFEDA>0
            //El rival tiene elo -> acumular
            //Buscar elo ms adecuado
            Do case
            case cuadro->elo>0
               nElo:=cuadro->elo
            case cuadro->eloFIDE>0
               nElo:=cuadro->eloFIDE
            othe
               nElo:=cuadro->eloFEDA
            endcase
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            Do case
            case nEloJug>0 .and. nElo-nEloJug>350
               nRc+=nEloJug+350
            case nEloJug>0 .and. nEloJug-nElo>350
               nRc+=nEloJug-350
            otherwise
               nRc+=nElo
            endcase
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Grabar registro
   if lAlgunNuevo=.f.
      lAlgunNuevo:=.t.
      // Crear fichero
      use (cUnidadProg+':\'+cCaminoProg+'\ks\KsFVANue.mod') new
      COPY STRU TO (cFich)
      use (cFich) alias ksfvanue exclusive
   endif

   dbselectarea('ksfvanue')
   dbappend()
   replace ksfvanue->torneo     with torneos->torneo
   replace ksfvanue->localidad  with torneos->localidad
   replace ksfvanue->fecha_ini  with torneos->fecha_ini
   replace ksfvanue->fecha_fin  with torneos->fecha_fin
   replace ksfvanue->licencia   with cuadro->lic
   replace ksfvanue->puntos     with nW
   replace ksfvanue->partidas   with nN
   replace ksfvanue->elorivales with nRc

   replace ksfvanue->jug         with cuadro->jug
   replace ksfvanue->elofide      with cuadro->elofide
   replace ksfvanue->elofeda      with cuadro->elofeda
   replace ksfvanue->elo            with cuadro->elo
   replace ksfvanue->club            with cuadro->club
   replace ksfvanue->cat            with cuadro->cat
   replace ksfvanue->cod_pais      with cuadro->cod_pais
   replace ksfvanue->cod_fide      with cuadro->cod_fide
   replace ksfvanue->cod_feda      with cuadro->cod_feda
   replace ksfvanue->fecha_nac      with cuadro->fecha_nac

   dbselectarea('cuadro')

Return nil

/*
 * Informe para la FEDA
 */

Function InFEDA(CFHtm)
local cFechaw, lError:=.F.

  //dbselectarea('cuadro')

  cFechaw:=if(torneos->fecha_ini<>torneos->fecha_fin,'del '+ ;
            dtoc(torneos->fecha_ini)+' al '+dtoc(torneos->fecha_fin),dtoc(torneos->fecha_ini))
  HtmFich := Html_Ini("\"+CurDir()+"\"+cFHtm+".htm",alltrim(torneos->torneo),;
             trim(torneos->localidad)+', '+cFechaw)

  Html_LineText(HtmFich, '<p class="updated">Informe del torneo para la FEDA')
  Html_Line(HtmFich)

  Html_Text(HtmFich,'<p class="normaltext">Ritmo de juego: '+trim(torneos->prim_contr)+;
     if(len(trim(torneos->segu_contr))>0,' + '+torneos->segu_contr,'')+'</p>')
  Html_Text(HtmFich,'<p>rbitro principal: '+trim(torneos->arbit_ppal)+'</p>')
  Html_Text(HtmFich,'<p>Cuadro del torneo: (Ver hoja adjunta)</p>')
  Html_Text(HtmFich,'<p>Resultados FEDA:</p>')
  Html_Text(HtmFich,'<pre>')

   dbselectarea('cuadro')
   // Comprobar que no faltan datos de los FIDEs
   dbeval( { ||ComprJugFEDA() } , { || len(trim(cuadro->cod_feda))>0 .or. cuadro->elofeda>0 } )

   if lError
      MsgInfo('Errores en datos FEDA. Corrijalos y ejecute de nuevo')

   else

      Html_LineTextK(HtmFich,'Cd.FEDA Nombre'+space(25)+'Sexo Aut. Fec.Nacim. Puntos Partidas Elo Rivales N Ranking')

      // Enviar al informe los datos de los FIDEs
      dbeval( { ||ProcJugFEDAInf(HtmFich) } , { || len(trim(cuadro->cod_feda))>0 .or. cuadro->elofeda>0 } )

   ENDIF

   Html_LineTextK(HtmFich,'')
   Html_Text(HtmFich,'</pre>')
   Html_Text(HtmFich,'<p></p>')
   Html_Text(HtmFich,'<p>Bloques FEDA:</p>')
   Html_Text(HtmFich,'<pre>')


   Html_LineTextK(HtmFich,'Nombre'+space(25)+'Sexo Aut. Fec.Nacim. Puntos Partidas Elo Rivales N Ranking')


   // Enviar al informe los datos de los no FEDA con bloque
   dbeval( { ||ProcBloqFEDAInf(HtmFich) } , { || len(trim(cuadro->cod_feda))=0 .and. cuadro->elofeda=0 } )

  Html_Text(HtmFich,'</pre>')
  Html_Text(HtmFich,'<p></p>')
  Html_Line(HtmFich)
  Html_Text(HtmFich,'<p align="right">Firmado: '+trim(torneos->arbit_ppal)+'</p>')

  MsgInfo('Fichero "Kersuizo.htm" con el informe para la FEDA creado')

Return nil

/*
 * Comprobar datos de un jugador FEDA
 */

Function ComprJugFEDA()

if len(trim(cuadro->cod_feda))>0 .and. cuadro->elofeda<=0

   MsgInfo('Error. El jugador '+trim(cuadro->jug)+' no tiene bien el Elo FEDA')
   lError:=.t.

endif

if len(trim(cuadro->cod_feda))=0 .and. cuadro->elofeda>0

   MsgInfo('Error. El jugador '+trim(cuadro->jug)+' no tiene bien el Cdigo FEDA')
   lError:=.t.

endif

Return nil

/*
 * Informe de variaciones de elo para FEDA
 */

Function ProcJugFEDAInf(HtmFich)
Local nW:=0, nN:=0, nRc:=0, nNReg
Local nRda, cCJug, nEloJug, cLin, nEloFIDEoFEDA

   //Hacer calculos
   nNReg:=cuadro->(recno())
   nEloJug:=cuadro->elofeda //para tener en cuenta el tema de los 350 puntos

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elofeda>0 .or. cuadro->elofide>0
            // El rival tiene FEDA o FIDE -> acumular
            nEloFIDEoFEDA:=if(cuadro->elofeda>0,cuadro->elofeda,cuadro->elofide)
            // Si tiene FEDA uso el FEDA, si no, el FIDE
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            Do case
            case nEloFIDEoFEDA-nEloJug>350
               nRc+=nEloJug+350
            case nEloJug-nEloFIDEoFEDA>350
               nRc+=nEloJug-350
            otherwise
               nRc+=nEloFIDEoFEDA
            endcase
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Escribir datos del jugador
   cLin:=''
   cLin+=cuadro->cod_feda+' '
   cLin+=cuadro->jug+' '
   cLin+=cuadro->sexo+'    '
   cLin+=cuadro->autonomia+'  '
   cLin+=dtoc(cuadro->fecha_nac)+' '
   cLin+=str(nW,4,1)+'   '
   cLin+=str(nN,2)+'       '
   cLin+=str(nRc,4)+'        '

   cLin+=str(cuadro->num,3)+' '

   Html_LineTextK(HtmFich,cLin)

Return nil

/*
 * Informe de bloques de elo para FEDA
 */

Function ProcBloqFEDAInf(HtmFich)
Local nW:=0, nN:=0, nRc:=0, nNReg
Local nRda, cCJug, cCInc, cCPtos

   //Hacer calculos
   nNReg:=cuadro->(recno())

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elofeda>0 .or. cuadro->elofide>0
            // El rival tiene FEDA o FIDE -> acumular
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            nRc+=if(cuadro->elofeda>0,cuadro->elofeda,cuadro->elofide)
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Grabar registro si ha hecho serie (3 o mas rivales con FEDA o FIDE)
   if nN>=3

      cLin:=''
      //cLin+=cuadro->cod_fide+' '
      cLin+=cuadro->jug+' '
      cLin+=cuadro->sexo+'    '
      cLin+=cuadro->autonomia+'  '
      cLin+=dtoc(cuadro->fecha_nac)+' '
      cLin+=str(nW,4,1)+'   '
      cLin+=str(nN,2)+'       '
      cLin+=str(nRc,4)+'        '

      cLin+=str(cuadro->num,3)+' '

      Html_LineTextK(HtmFich,cLin)

   ENDIF

RETURN NIL

/*
 * Fichero de variaciones de elo para FEDA
 */

Function FiFEDA()
local cFich:='KsFEDA', lError:=.f.

   // Crear fichero
   use (cUnidadProg+':\'+cCaminoProg+'\ks\KsFEDA.mod') new
   COPY STRU TO (cFich)
   use (cFich) alias ksfeda exclusive

   dbselectarea('cuadro')
   // Comprobar que no faltan datos de los FIDEs
   dbeval( { ||ComprJugFEDA() } , { || len(trim(cuadro->cod_feda))>0 .or. cuadro->elofeda>0 } )

   if lError
      MsgInfo('Errores en datos FEDA. Corrijalos y ejecute de nuevo')

   else

      // Enviar al fichero los datos de los FIDEs
      dbeval( { ||ProcJugFEDA() } , { || len(trim(cuadro->cod_feda))>0 .or. cuadro->elofeda>0 } )

      ksfeda->(dbclosearea())
      MsgInfo('Fichero '+cFich+'.dbf con datos para la FEDA creado')

   endif

Return nil

/*
 * Tratar un jugador FEDA
 */

Function ProcJugFEDA()
Local nW:=0, nN:=0, nRc:=0, nNReg
Local nRda, cCJug, nEloJug, nEloFIDEoFEDA

   //Hacer calculos
   nNReg:=cuadro->(recno())
   nEloJug:=cuadro->elofeda //para tener en cuenta el tema de los 350 puntos

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elofeda>0 .or. cuadro->elofide>0
            // El rival tiene FEDA o FIDE -> acumular
            nEloFIDEoFEDA:=if(cuadro->elofeda>0,cuadro->elofeda,cuadro->elofide)
            // Si tiene FEDA uso el FEDA, si no, el FIDE
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            Do case
            case nEloFIDEoFEDA-nEloJug>350
               nRc+=nEloJug+350
            case nEloJug-nEloFIDEoFEDA>350
               nRc+=nEloJug-350
            otherwise
               nRc+=nEloFIDEoFEDA
            endcase
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Grabar registro
   dbselectarea('ksfeda')
   dbappend()
   replace ksfeda->id_code   with cuadro->cod_feda
   replace ksfeda->name      with cuadro->jug
   replace ksfeda->sex       with cuadro->sexo
   replace ksfeda->autonomia with cuadro->autonomia
   replace ksfeda->birthdate with cuadro->fecha_nac
   replace ksfeda->w         with nW
   replace ksfeda->n         with nN
   replace ksfeda->rc        with nRc

   replace ksfeda->n_ranking with cuadro->num

   dbselectarea('cuadro')

Return nil

/*
 * Fichero de jugadores con bloque de elo para FEDA
 */

Function FiBloqFEDA()
private cFich:='KsFEDABloq', lAlgunBloque:=.f.

   // Crear fichero (se crea slo si hay alguno con bloque)
   dbselectarea('cuadro')

   // Enviar al fichero los datos de los no FEDA con bloque
   dbeval( { ||ProcBloqFEDA() } , { || len(trim(cuadro->cod_feda))=0 .and. cuadro->elofeda=0 } )

   if lAlgunBloque
      ksfeda->(dbclosearea())
      MsgInfo('Fichero '+cFich+'.dbf con bloques para la FEDA creado')
   else
      MsgInfo('No ha habido ningn bloque FEDA en el torneo')
   endif

Return nil

/*
 * Tratar un jugador no FIDE para ver si ha hecho bloque
 */

Function ProcBloqFEDA()
Local nW:=0, nN:=0, nRc:=0, nNReg
Local nRda, cCJug, cCInc, cCPtos

   //Hacer calculos
   nNReg:=cuadro->(recno())

   for i:=1 to torneos->n_rondas
      nRda:=alltrim(str(i))
      cCJug :='cuadro->r'+nRda+'j'
      cCInc :='cuadro->r'+nRda+'i'
      cCPtos:='cuadro->r'+nRda+'p'
      if &cCJug>0 .and. &cCJug<=cuadro->(lastrec()) .and. upper(&cCInc)<>'I'
         // Jug
         cuadro->(dbgoto(&cCJug))
         if cuadro->elofeda>0 .or. cuadro->elofide>0
            // El rival tiene FEDA o FIDE -> acumular
            nN++
            nW+=if(&cCPtos$'',.5,1-val(&cCPtos))
            nRc+=if(cuadro->elofeda>0,cuadro->elofeda,cuadro->elofide)
         endif
      endif
      cuadro->(dbgoto(nNReg))
   next
   nRc:=round(nRc/nN,0)

   cuadro->(dbgoto(nNReg))

   //Grabar registro si ha hecho serie (3 o mas rivales con FEDA o FIDE)
   if nN>=3

      if lAlgunBloque=.f.
         lAlgunBloque:=.t.
         // Crear fichero
         use (cUnidadProg+':\'+cCaminoProg+'\ks\KsFEDA.mod') new
         COPY STRU TO (cFich)
         use (cFich) alias ksfeda exclusive
      endif

      dbselectarea('ksfeda')
      dbappend()
      //replace ksfide->id_code   with cuadro->cod_fide
      replace ksfeda->name      with cuadro->jug
      replace ksfeda->sex       with cuadro->sexo
      replace ksfeda->autonomia with cuadro->autonomia
      replace ksfeda->birthdate with cuadro->fecha_nac
      replace ksfeda->w         with nW
      replace ksfeda->n         with nN
      replace ksfeda->rc        with nRc

      replace ksfeda->n_ranking with cuadro->num
   endif
   dbselectarea('cuadro')

Return nil



/*
 */



